<?php
/*
This file is part of the tts2 module, written by Franky Van Liedekerke for more.groupware Contact: liedekef@pandora.be, and based on the original tts module.
*/

/* $Id: ticket.class.php,v 1.5 2005/03/01 20:13:51 liedekef Exp $ */

define("ISOZERODATE", "1000-01-01 00:00:00+00");

class Ticket{
	var $id_ticket = -1;
	var $id_project = -1;
	var $id_company = -1;
	var $id_priority = -1;
	var $id_severity = -1;
	var $id_resolution = -1;
	var $id_owner = -1;
	var $id_assigned = -1;
	var $id_status = -1;
	var $id_wfinstance = -1;
	var $lu_date = -1;
	var $short_desc = "";
	var $long_desc = "";
	var $all_names;
        var $prioritylist;
        var $statuslist;
        var $severitylist;
        var $resolutionlist;
        var $status_wflist;
        var $status_pause=-1;



	/*
	constructor
	*/
	function Ticket() {
		//arg 1 : $id
		$arguments = func_get_args();
		switch(func_num_args()) {
			case 0:
				//nothing to do
				$this->id_ticket=0;
				break;
			case 1:
				$this->id_ticket=(int)$arguments[0];
				break;	
		}
		$this->load();
	}
	
	
    function opCreate() {
        global $conn, $smarty, $appconf;

        $id_project =         (int)$_POST["id_project"];
        $id_company =          (int)$_POST["id_company"];
        $id_priority =         (int)$_POST["id_priority"];
        $id_severity =         (int)$_POST["id_severity"];
        $id_resolution =       (int)$_POST["id_resolution"];
        $id_owner =            (int)$_POST["id_owner"];
        $id_assigned =         (int)$_POST["id_assigned"];
        $id_status =           (int)$_POST["id_status"];
                                                                                
        $shortdescription=$conn->QMagic($_POST["short_desc"]);
        $longdescription=$conn->QMagic($_POST["long_desc"]);

        if(queryRights2_bool('root_modules_tts2_write')){
	   // create a unique ID, I would use autoincrement myself ...
	   $ticket_index = mgw_genID('mgw__seq_tts2');
	   $ticket_history_index = mgw_genID('mgw__seq_tts2_history');

           $sql="INSERT INTO mgw_tts2 (id, id_project, id_company, id_priority, id_severity, id_resolution, id_owner, id_assigned, id_status, lu_date, short_desc, long_desc)
             VALUES ($ticket_index,$id_project,$id_company,$id_priority,$id_severity,$id_resolution,$id_owner,$id_assigned,$id_status,".$conn->DBTimeStamp(time()).",$shortdescription,$longdescription)";
           if(!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

	   $qcomment = $conn->QMagic("Ticket opened");
	   $this->AddHistory($ticket_index, $qcomment, $id_owner, $id_status);
	   return true;
	} else {
	       $smarty->assign("errorheader",Lang::getLanguageString("permerror"));
	       $smarty->assign("permerror",Lang::getLanguageString("permerrormsg"));
	       $smarty->display($appconf["gentemplates"] ."/perm_errors.tpl");
	       exit();
	}
    }

    function opComment() {
        global $conn, $smarty, $appconf;

	$modifier = (int)$_POST["modifier"];
        $id_status=(int)$_POST["id_status"];
	$qcomment = $conn->QMagic($_POST['_comment']);

	// UPDATE STATUS
	$sql = "UPDATE mgw_tts2 SET id_status=$id_status, lu_date=". $conn->DBTimeStamp(time())." WHERE id=".$this->id_ticket;
	if(!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

	$this->AddHistory($this->id_ticket, $qcomment, $modifier, $id_status);
	return true;
    }

    function opUnpause() {
	global $conn;
        if(queryRights2_bool('root_modules_tts2_write')){
	   $sql = "SELECT id, oldstatus FROM mgw_tts2_history WHERE id_ticket=".$this->id_ticket;
	   if(!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	   $res->MoveLast();
	   $row = $res->FetchRow();

	   // for unpause, the record gets the status back before the unpause
	   $curstatus=$row["oldstatus"];
	   // UPDATE STATUS
	   $sql = "UPDATE mgw_tts2 SET id_status=$curstatus, lu_date=". $conn->DBTimeStamp(time())." WHERE id=$this->id_ticket";
	   if(!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

	   // INSERT NEW HISTORY RECORD
	   $qcomment = $conn->QMagic("Ticket unpaused");
	   $this->AddHistory($this->id_ticket, $qcomment, $this->id_owner, $curstatus);
	   return true;
	} else {
	       $smarty->assign("errorheader",Lang::getLanguageString("permerror"));
	       $smarty->assign("permerror",Lang::getLanguageString("permerrormsg"));
	       $smarty->display($appconf["gentemplates"] ."/perm_errors.tpl");
	       exit();
	}
    }

    function opUpdate() {
        global $conn, $smarty, $appconf;

	if(queryRights2_bool('root_modules_tts2_modify') ||
	   queryRights2_bool('root_modules_tts2_modifyothers')) {

           $id_status=(int)$_POST["id_status"];
           $id_assigned=(int)$_POST["id_assigned"];
           $id_priority=(int)$_POST["id_priority"];    
           $id_severity=(int)$_POST["id_severity"];    
           $id_resolution=(int)$_POST["id_resolution"];    
           $id_company=(int)$_POST["id_company"];    
           $id_project=(int)$_POST["id_project"];    
	   $modifier = (int)$_POST["modifier"];
            
           $shortdescription=$conn->QMagic($_POST["short_desc"]);
           $longdescription=$conn->QMagic($_POST["long_desc"]);
        
    
           $sql="UPDATE mgw_tts2 SET id_project=".$id_project.", id_status=".$id_status.", id_priority=".$id_priority.", id_severity=".$id_severity.", id_resolution=".$id_resolution.", id_assigned=".$id_assigned.", id_company=".$id_company.", short_desc=".$shortdescription.", long_desc=".$longdescription." WHERE id=".$this->id_ticket;
    
           if(!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

	   $qcomment = $conn->QMagic("Ticket info edited");
	   $this->AddHistory($this->id_ticket, $qcomment, $modifier, $id_status);
	   return true;
	} else {
	    $smarty->assign("errorheader",Lang::getLanguageString("permerror"));
	    $smarty->assign("permerror",Lang::getLanguageString("permerrormsg"));
	    $smarty->display($appconf["gentemplates"] ."/perm_errors.tpl");
	    exit();
	}
    }
    
    
    function viewSummary() {
	global $conn, $smarty, $appconf;
		
	
        //declare the array used to display boxes
        $byDate=array();
        $byUser=array();
        $byStatus=array();
        $bySeverity=array();
        $byPriority=array();
        $byResolution=array();    
        
       
        //by priority
        $sql="SELECT id_priority, COUNT(lu_date) AS count FROM mgw_tts2 GROUP BY id_priority ORDER BY id_priority";
        if(!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
        $i=0;
        $row=array();
        while(!$res->EOF) { 
        	$row[$i] = $res->FetchRow();
        	$row[$i]["id_priority"] = $this->prioritylist[$row[$i]["id_priority"]];    	
        	 $i++;
        }
        $byPriority=$row;    
        $smarty->assign("priority",$byPriority);
        
        //by severity
        $sql="SELECT id_severity, COUNT(lu_date) AS count FROM mgw_tts2 GROUP BY id_severity ORDER BY id_severity";
        if(!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
        $i=0;
        $row=array();
        while(!$res->EOF) { 
        	$row[$i] = $res->FetchRow();
        	$row[$i]["id_severity"] = $this->severitylist[$row[$i]["id_severity"]];
        	 $i++;
        }
        $bySeverity=$row;    
        $smarty->assign("severity",$bySeverity);
    
        //by resolution
        $sql="SELECT id_resolution, COUNT(lu_date) AS count FROM mgw_tts2 GROUP BY id_resolution ORDER BY id_resolution";
        if(!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
        $i=0;
        $row=array();
        while(!$res->EOF) { 
        	$row[$i] = $res->FetchRow();
        	$row[$i]["id_resolution"] = $this->resolutionlist[$row[$i]["id_resolution"]];
        	 $i++;
        }
        $byResolution=$row;    
        $smarty->assign("resolution",$byResolution);
    
    
        //by user
        $sql="SELECT b.username, b.id, COUNT(a.id) AS count 
              FROM mgw_tts2 a, mgw_users b 
              WHERE a.id_owner=b.id
              GROUP BY b.id, b.username, a.id_owner, a.id_priority
              ORDER BY a.id_priority";
        if(!$res2 = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
        $i=0;
    	//to avoid EALL notice
    	$row2=array();
        while(!$res2->EOF) {
        $row2[$i] = $res2->FetchRow();
            $i++;    
        }
        $byUser=$row2;
        $smarty->assign("user",$byUser);    
        
        //by status
        $sql="SELECT curstatus AS status, COUNT(end_date) AS count FROM mgw_tts2_history WHERE end_date='".ISOZERODATE."' GROUP BY status ORDER BY status";
        if(!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
        $i=0;
        $row=array();
        while(!$res->EOF) { 
        	$row[$i] = $res->FetchRow(); 
        	$row[$i]["status"] = $this->statuslist[$row[$i]["status"]];
        	$i++;
        }
        $byStatus=$row;    
        $smarty->assign("status",$byStatus);    
        
         //by day
        $sql="SELECT a.id, a.lu_date FROM mgw_tts2 a ";
        if(!$res5 = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
        $i=0;
    	//to avoid EALL notice
    	$temp=array();
        while(!$res5->EOF) {
            $row5[$i]= $res5->FetchRow();
            $row5[$i]["lu_date"] =round((date("U",time()) - $res5->UnixTimeStamp($row5[$i]["lu_date"],"U"))/ (3600*24),0);
            $temp[$row5[$i]["lu_date"]]=$temp[$row5[$i]["lu_date"]]+1;                
            $i++;    
        }
        
        $i=0;
    	//to avoid EALL notice
    	$byDay=array();	
    	
        if(count($temp) > 0){
    		while(list($k,$v)=each($temp)) {
    		    $byDay[$i]["num"]=$k;
    		    $byDay[$i]["count"]=$v;        
    		    $i++;
    		}
        }
        $smarty->assign("day",$byDay);

        $smarty->display("tts2_summary.tpl");
    }
	
    function viewNewForm() {
        global $conn,$smarty, $appconf;

	if(queryRights2_bool('root_modules_tts2_write')){
	    include(INCLUDEPATH . "mSelectBox.class.php");
    	
    	    $smarty->assign("idtxt", Lang::getLanguageString("id"));
            $smarty->assign("id_ticket", 0);	
            $smarty->assign("mode","new");
            $smarty->assign("current_tts",$id);
            $smarty->assign("editticket",Lang::getLanguageString("newticket"));
	    // define the submit button
            $smarty->assign("suvalue",Lang::getLanguageString("create"));
            $smarty->assign("suname","create");
            $smarty->assign("suclass","submit");
    
	    // COMPANY
    	    $smarty->assign("companytxt", Lang::getLanguageString("company"));
            $sql="SELECT id, name1 FROM mgw_companies";
            $sb = new mSelectBox("id_company");
            $sb->setContentType("sql");
            $sb->setSQLvalue("id");
            $sb->setSQLcontent("name1");
            $sb->addContent($sql);
            $sb->addOption("0", Lang::getLanguageString("choosecompany"), "pre");
            $smarty->assign("companysb", $sb->draw());
            unset($sb);

	    // CATEGORY
            $sql="SELECT project_id, title FROM mgw_projects";
            $sb = new mSelectBox("id_project");
            $sb->setContentType("sql");
            $sb->setSQLvalue("project_id");
            $sb->setSQLcontent("title");
            $sb->addContent($sql);
            $sb->addOption("0", Lang::getLanguageString("chooseproject"), "pre");
            $smarty->assign("projectsb", $sb->draw());
            unset($sb);

	    // ASSIGNED TO
            $concat=$conn->Concat("lastname", "', '", "firstname");
            // fixing empty array - emailtotom
            $name = array();
            #$sql="SELECT $concat AS name, id FROM mgw_users WHERE is_ldap=1";
            $sql="SELECT $concat AS name, id FROM mgw_users WHERE level>0";
            if(!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
            $i=1;
            while(!$res->EOF) {
                $name[$res->Fields("id")] = $res->Fields("name");
                $res->MoveNext();
                $i++;
            }

            $sb = new mSelectBox("id_assigned");
            $sb->setContentType("arr");
            $sb->addContent($name);
            $sb->addOption("NULL", Lang::getLanguageString("chooseassigned"), "pre");
            $smarty->assign("assignedsb", $sb->draw());
            unset($sb);

            //OWNER text
            $sql="SELECT * FROM mgw_users WHERE id=".$_SESSION["MGW"]->userid;
            if(!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
            $row = $res->FetchRow();
            $smarty->assign("ownername",$row["lastname"].", ".$row["firstname"]);
            $smarty->assign("id_owner",$row["id"]);
    
    	    //PRIOTITY
            $smarty->assign("priority", Lang::getLanguageString("priority"));
            $sb = new mSelectBox("id_priority",4);
            $sb->setContentType("arr");
            $sb->addContent($this->prioritylist);
            $smarty->assign("prioritysb", $sb->draw());
            unset($sb);    
    
    	    //SEVERITY
            $smarty->assign("severity", Lang::getLanguageString("severity"));
            $sb = new mSelectBox("id_severity",0);
            $sb->setContentType("arr");
            $sb->addContent($this->severitylist);
            $smarty->assign("severitysb", $sb->draw());
            unset($sb);    
    
    	    //RESOLUTION
            $smarty->assign("resolution", Lang::getLanguageString("resolution"));
            $sb = new mSelectBox("id_resolution",0);
            $sb->setContentType("arr");
            $sb->addContent($this->resolutionlist);
            $smarty->assign("resolutionsb", $sb->draw());
            unset($sb);    
        
    	    //STATUS
            $smarty->assign("status", Lang::getLanguageString("status"));
            $sb = new mSelectBox("id_status",0);
            $sb->setContentType("arr");
            $sb->addContent($this->statuslist);
            $smarty->assign("statussb", $sb->draw());
            unset($sb);    
        
            $smarty->clear_cache("tts2_list.tpl",$_SESSION["MGW"]->userid);
            $smarty->display('tts2_ticket.tpl','new');

	    return true;
	} else{
	    $smarty->assign("errorheader",Lang::getLanguageString("permerror"));
	    $smarty->assign("permerror",Lang::getLanguageString("permerrormsg"));
	    $smarty->display($appconf["gentemplates"] ."/perm_errors.tpl");
	    exit();
	}
    }

    function viewDetails() {
        global $conn,$smarty;

        $smarty->assign("assignedsb", $this->all_names[$this->id_assigned]);
        $smarty->assign("ownername",$this->all_names[$this->id_owner]);		

	$smarty->assign("priority", Lang::getLanguageString("priority"));
	$smarty->assign("prioritysb", $this->prioritylist[$this->id_priority]);

	$smarty->assign("severity", Lang::getLanguageString("severity"));
	$smarty->assign("severitysb", $this->severitylist[$this->id_severity]);

	$smarty->assign("resolution", Lang::getLanguageString("resolution"));
	$smarty->assign("resolutionsb", $this->resolutionlist[$this->id_resolution]);
    
        $sql="SELECT title FROM mgw_projects where project_id = $this->id_project";
        if(!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
   	$row = $res->FetchRow();
	$smarty->assign("project", Lang::getLanguageString("project"));
	$smarty->assign("projectsb", $row["title"]);
    
	$smarty->assign("status", Lang::getLanguageString("status"));
	$smarty->assign("statussb", $this->statuslist[$this->id_status]);
    
        $sql="SELECT name1 FROM mgw_companies where id = $this->id_company";
        if(!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
   	$row = $res->FetchRow();
	$smarty->assign("companytxt", Lang::getLanguageString("company"));
	$smarty->assign("companysb", $row["name1"]);
    
        $smarty->assign("short_descval", $this->short_desc);
        $smarty->assign("long_descval", $this->long_desc);

        $smarty->assign("idtxt", Lang::getLanguageString("id"));
        $smarty->assign("id_ticket", $this->id_ticket);

	// View all relevant comments
	$comments=array();
	$comments=$this->GetAllComments($this->id_ticket);
        $smarty->assign("commentstxt", Lang::getLanguageString("comments"));
	$smarty->assign_by_ref('comments', $comments);

	$smarty->display('tts2_ticket.tpl');

	return true;
    }

    function viewCommentForm() {
        global $smarty, $appconf;
	global $user;
        
    	if(queryRights2_bool('root_modules_tts2_comment')) {
            //STATUS
	    include(INCLUDEPATH . "mSelectBox.class.php");
            $smarty->assign("status", Lang::getLanguageString("status"));
	    // if state is under workflow control and user has no admin rights
            if (($this->status_wflist[$this->id_status]>0) &&
		!(queryRights2_bool('root_modules_tts2_admin'))) {
                $smarty->assign("statussb","<SELECT NAME=id_status><OPTION VALUE=$this->id_status>".$this->statuslist[$this->id_status]."</SELECT>");

                $activities=array();
                $activities=$this->GetWorkflowActivities();
                $smarty->assign("workflow_links",$activities);
                $smarty->assign("iid",$this->id_wfinstance);
		$smarty->assign("workflow_ctrl","Workflow controlled status!");

            } else {
		$sb10 = new mSelectBox("id_status",$this->id_status);
		$sb10->setContentType("arr");
		$sb10->addContent($this->statuslist);
		$smarty->assign("statussb", $sb10->draw());
		if ($this->status_wflist[$this->id_status]>0) {
		   // let's remind admin also that this state
		   // is workflow controlled
		   $activities=array();
		   $activities=$this->GetWorkflowActivities();
		   $smarty->assign("workflow_links",$activities);
		   $smarty->assign("iid",$this->id_wfinstance);
		   $smarty->assign("workflow_ctrl","Workflow controlled status!");
		} else {
		   $activities=array();
		   $smarty->assign("workflow_links",$activities);
		   $smarty->assign("workflow_ctrl","");
		}
		unset($sb10);
            }

            // ID 
            $smarty->assign("idtxt", Lang::getLanguageString("id"));
            $smarty->assign("id_ticket", $this->id_ticket);
            $smarty->assign("modifier",$user);

	    // SUBMIT 
            $smarty->assign('action', Lang::getLanguageString("action"));
            $smarty->assign('suvalue', Lang::getLanguageString("addcomment"));
            $smarty->assign('suclass', "submit");
            $smarty->assign('suname', "addcomment");

            $smarty->display('tts2_comment.tpl');
    	} else {
    	    $smarty->assign("errorheader",Lang::getLanguageString("permerror"));
    	    $smarty->assign("permerror",Lang::getLanguageString("permerrormsg"));
    	    $smarty->display($appconf["gentemplates"] ."/perm_errors.tpl");
    	    exit();
	}
    }

    function viewEditForm() {
        global $conn, $smarty, $appconf;
	global $user;
        
	// first check for pause state, this the catch the case 
	// where a user directly goes to index.php?action=editform...
	$sql="SELECT count(id) as pause_count FROM mgw_tts2 WHERE id_assigned=$user AND id_status=$this->status_pause";
        if(!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
        $row = $res->FetchRow();
	$pause_count=$row[pause_count];
	if ($pause_count>0) {
	   redirect("./index.php?".SID);
	}

	// now check the permission and do the stuff ...
    	if(queryRights2_bool('root_modules_tts2_modify') || queryRights2_bool('root_modules_tts2_modifyothers')) {
    	    include_once(INCLUDEPATH . "mSelectBox.class.php");
    
            // Id 
            $smarty->assign("idtxt", Lang::getLanguageString("id"));
            $smarty->assign("id_ticket", $this->id_ticket);
            
            $smarty->assign("modifier",$user);
            $smarty->assign("mode","modify");
            $smarty->assign("suname","modify");
            $smarty->assign("suvalue",Lang::getLanguageString("modify"));
            $smarty->assign("suclass","submit");
            
            //owner text
            $smarty->assign("ownername",$this->all_names[$this->id_owner]);
            $smarty->assign("id_owner",$this->id_owner);
            
            $sb7 = new mSelectBox("id_assigned",$this->id_assigned);
            $sb7->setContentType("arr");
            $sb7->addContent($this->all_names);
            $sb7->addOption("-1", Lang::getLanguageString("chooseassigned"), "pre");
            $smarty->assign("assignedsb", $sb7->draw());
            unset($sb7);
            
            
            //PRIOTITY
            $smarty->assign("priority", Lang::getLanguageString("priority"));
            $sb8 = new mSelectBox("id_priority",$this->id_priority);
            $sb8->setContentType("arr");
            $sb8->addContent($this->prioritylist);
            $smarty->assign("prioritysb", $sb8->draw());
            unset($sb8);            
            
            //SEVERITY
            $smarty->assign("severity", Lang::getLanguageString("severity"));
            $sb9 = new mSelectBox("id_severity",$this->id_severity);
            $sb9->setContentType("arr");
            $sb9->addContent($this->severitylist);
            $smarty->assign("severitysb", $sb9->draw());
            unset($sb9);    
            
            //RESOLUTION
            $smarty->assign("resolution", Lang::getLanguageString("resolution"));
            $sb10 = new mSelectBox("id_resolution",$this->id_resolution);
            $sb10->setContentType("arr");
            $sb10->addContent($this->resolutionlist);
            $smarty->assign("resolutionsb", $sb10->draw());
            unset($sb10);  
            
            //STATUS
            $smarty->assign("status", Lang::getLanguageString("status"));
	    // if state is under workflow control and user has no admin rights
	    if (($this->status_wflist[$this->id_status]>0) &&
		!(queryRights2_bool('root_modules_tts2_admin'))) {
		$smarty->assign("statussb","<SELECT NAME=_status><OPTION VALUE=$this->id_status>".$this->statuslist[$this->id_status]."</SELECT>");

                $activities=array();
                $activities=$this->GetWorkflowActivities();
                $smarty->assign("workflow_links",$activities);
                $smarty->assign("iid",$this->id_wfinstance);
		$smarty->assign("workflow_ctrl","Workflow controlled status!");

	    } else {
		$sb10 = new mSelectBox("id_status",$this->id_status);
		$sb10->setContentType("arr");
		$sb10->addContent($this->statuslist);
		$smarty->assign("statussb", $sb10->draw());
		if ($this->status_wflist[$this->id_status]>0) {
		   // let's remind admin also that this state
		   // is workflow controlled
                   $activities=array();
                   $activities=$this->GetWorkflowActivities();
                   $smarty->assign("workflow_links",$activities);
                   $smarty->assign("iid",$this->id_wfinstance);
		   $smarty->assign("workflow_ctrl","Workflow controlled status!");
		} else {
                   $activities=array();
                   $smarty->assign("workflow_links",$activities);
		   $smarty->assign("workflow_ctrl","");
		}
		unset($sb10);  
	    }

	    // COMPANY
    	    $smarty->assign("companytxt", Lang::getLanguageString("company"));
            $sql="SELECT id, name1 FROM mgw_companies";
            $sb = new mSelectBox("id_company",$this->id_company);
            $sb->setContentType("sql");
            $sb->setSQLvalue("id");
            $sb->setSQLcontent("name1");
            $sb->addContent($sql);
            $sb->addOption("0", Lang::getLanguageString("choosecompany"), "pre");
            $smarty->assign("companysb", $sb->draw());
            unset($sb);

	    // CATEGORY
            $sql="SELECT project_id, title FROM mgw_projects";
            $sb = new mSelectBox("id_project",$this->id_project);
            $sb->setContentType("sql");
            $sb->setSQLvalue("project_id");
            $sb->setSQLcontent("title");
            $sb->addContent($sql);
            $sb->addOption("0", Lang::getLanguageString("chooseproject"), "pre");
            $smarty->assign("projectsb", $sb->draw());
            unset($sb);
            
            $smarty->assign("short_descval", $this->short_desc);
            $smarty->assign("long_descval", $this->long_desc);
            
	    // View all relevant comments
	    $comments=array();
	    $comments=$this->GetAllComments($this->id_ticket);
	    $smarty->assign_by_ref('comments', $comments);
            $smarty->assign("commentstxt", Lang::getLanguageString("comments"));

            $smarty->display('tts2_ticket.tpl');

    	    return true;
    	} else{
    	    $smarty->assign("errorheader",Lang::getLanguageString("permerror"));
    	    $smarty->assign("permerror",Lang::getLanguageString("permerrormsg"));
    	    $smarty->display($appconf["gentemplates"] ."/perm_errors.tpl");
    	    exit();
    	}
    }

    function ViewList() {
        global $conn, $smarty, $appconf;
	global $user;
        
        //to avoid EALL notice
        $urls=array();
	include_once(INCLUDEPATH . "mSelectBox.class.php");        
    
        // =================================================
        //	              List View
        // =================================================
        // if user wants icons, assign icons if not -> not
        if($_SESSION["MGW"]->settings["iconmode"]==1) {
            $detailsym = "<img src=\"". $appconf["imgpathgeneral"]. "/details_". $_SESSION["MGW"]->settings["iconid"]. ".gif\" border=\"0\" alt=\"".Lang::getLanguageString("details")."\" title=\"".Lang::getLanguageString("details")."\">";
            $editsym = "<img src=\"". $appconf["imgpathgeneral"]. "/edit_". $_SESSION["MGW"]->settings["iconid"]. ".gif\" border=\"0\" alt=\"".Lang::getLanguageString("edit")."\" title=\"".Lang::getLanguageString("edit")."\">";
            $delsym = "<img src=\"". $appconf["imgpathgeneral"]. "/delete_". $_SESSION["MGW"]->settings["iconid"]. ".gif\" border=\"0\" alt=\"".Lang::getLanguageString("delete")."\" title=\"".Lang::getLanguageString("delete")."\">";
            $prevsym = "<img src=\"". $appconf["imgpathgeneral"]. "/left_". $_SESSION["MGW"]->settings["iconid"]. ".gif\" border=\"0\">";
            $nextsym = "<img src=\"". $appconf["imgpathgeneral"]. "/right_". $_SESSION["MGW"]->settings["iconid"]. ".gif\" border=\"0\">";
            $privsym = "<img src=\"" . $appconf["imgpathgeneral"] . "/private_". $_SESSION["MGW"]->settings["iconid"]. ".gif\" alt=\"Private\" border=\"0\">";
            $smarty->assign("iconid", $_SESSION["MGW"]->settings["iconid"]);
            $smarty->assign("iconmode", true);
        } else {
            $detailsym = Lang::getLanguageString("details");
            $editsym = Lang::getLanguageString("edit");
            $delsym = Lang::getLanguageString("delete");
            $privsym = Lang::getLanguageString("private");
            $prevsym = "&lt;&lt;--|";
            $nextsym = "|--&gt;&gt;";
            $smarty->assign("iconmode", false);
        }
	$prevlink="index.php?ppage=1";
	$nextlink="index.php?npage=1";

        //construction of the where sentence
	// Now using REQUEST because this can be set
	//   either by POST (for searces)
	//   or by GET (for previous/next pages)

        $where = "";

	// search for specific ticket id
	if (isset($_REQUEST["id_ticket"])) {
           $id_ticket = (int)$_REQUEST["id_ticket"];
           if ($id_ticket > 0) {
        	$where .= " AND mgw_tts2.id = $id_ticket";	
	   }
	   $prevlink .= "&amp;id_ticket=$id_ticket";
	   $nextlink .= "&amp;id_ticket=$id_ticket";
        }

	// search for specific owner
	if (isset($_REQUEST["id_owner"])) {
           $id_owner = (int)$_REQUEST["id_owner"];
	   if ($id_owner > -1) {
        	$where.=" AND mgw_tts2.id_owner = $id_owner";	
	   }
	   $prevlink .= "&amp;id_owner=$id_owner";
	   $nextlink .= "&amp;id_owner=$id_owner";
        }

	// search for specific assigned user
	// defaults to unassigned
	if (isset($_REQUEST["id_assigned"])) {
           $id_assigned = (int)$_REQUEST["id_assigned"];
	} else {
	   //$id_assigned = $user;
	   $id_assigned = -1;
	}
	if ($id_assigned >-1) {
           $where.=" AND mgw_tts2.id_assigned = $id_assigned";
	   $prevlink .= "&amp;id_assigned=$id_assigned";
	   $nextlink .= "&amp;id_assigned=$id_assigned";
	}

	// search for specific priority
	if (isset($_REQUEST["id_priority"])) {
           $id_priority = (int)$_REQUEST["id_priority"];
	   if ($id_priority > -1) {
        	$where.=" AND mgw_tts2.id_priority = $id_priority";
	   }
	   $prevlink .= "&amp;id_priority=$id_priority";
	   $nextlink .= "&amp;id_priority=$id_priority";
        }

	// search for specific severity
	if (isset($_REQUEST["id_severity"])) {
	   $id_severity = (int)$_REQUEST["id_severity"];
	   if ($id_severity > -1) {
        	$where.=" AND mgw_tts2.id_severity = $id_severity";
	   }
	   $prevlink .= "&amp;id_severity=$id_severity";
	   $nextlink .= "&amp;id_severity=$id_severity";
        }

	// search for specific resolution
	if (isset($_REQUEST["id_resolution"])) {
           $id_resolution = (int)$_REQUEST["id_resolution"];
	   if ($id_resolution > -1) {
        	$where.=" AND mgw_tts2.id_resolution = $id_resolution";
	   }
	   $prevlink .= "&amp;id_resolution=$id_resolution";
	   $nextlink .= "&amp;id_resolution=$id_resolution";
        }

	// search for specific status
	// defaults to status 0
	if (isset($_REQUEST["id_status"])) {
           $id_status = (int)$_REQUEST["id_status"];
	} else {
	   $id_status=0;
	}
	if ($id_status > -1) {
           $where.=" AND mgw_tts2.id_status = $id_status";	
	}
	$prevlink .= "&amp;id_status=$id_status";
	$nextlink .= "&amp;id_status=$id_status";

	// search for specific project
	if (isset($_REQUEST["id_project"])) {
           $id_project = (int)$_REQUEST["id_project"];
	   if ($id_project > -1) {
        	$where.=" AND mgw_tts2.id_project = $id_project";
	   }
	   $prevlink .= "&amp;id_project=$id_project";
	   $nextlink .= "&amp;id_project=$id_project";
        }

	// search for specific company
	if (isset($_REQUEST["id_company"])) {
           $id_company = (int)$_REQUEST["id_company"];
	   if ($id_company > -1) {
        	$where.=" AND mgw_tts2.id_company = $id_company";
	   }
	   $prevlink .= "&amp;id_company=$id_company";
	   $nextlink .= "&amp;id_company=$id_company";
        }

	// set the page number
	// defaults to 0
	if(isset($_REQUEST["_page"])) {
        	$page = (int)$_REQUEST["_page"];
	} else {
		$page = 1;
	}
	$prevpage=$page-1;
	$nextpage=$page+1;
	$prevlink .= "&amp;_page=$prevpage";
	$nextlink .= "&amp;_page=$nextpage";
        
	$sql="SELECT count(id) as pause_count FROM mgw_tts2 WHERE id_assigned=$user AND id_status=$this->status_pause";
        if(!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
        $row = $res->FetchRow();
	$pause_count=$row[pause_count];

	// is pause status is detected for one ticket, ignore
	// all filters, and just show the paused ticket
	if ($pause_count>0) {
	    $where = " AND id_assigned=$user AND id_status=$this->status_pause";
	}
	
        $sql="SELECT * FROM mgw_tts2 WHERE 1=1 $where";
        if(!$res = $conn->PageExecute($sql, $_SESSION["MGW"]->settings["list_items_number"], $page))
            exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
        $arr_result=array();

	// Paging Part
	$prevlink="<A HREF=\"$prevlink\">$prevsym</A>";
	$nextlink="<A HREF=\"$nextlink\">$nextsym</A>";
        if(!$res->AtFirstPage()) {
            $smarty->assign("prevlink", $prevlink);
        }
        // if NOT on last page
        if(!$res->AtLastPage()) {
            $smarty->assign("nextlink", $nextlink);
        }
	// Paging Part


        $i=0;
        // while(!$res->EOF) {
        //       $arr_result[1][$i]=$res->FetchRow();
        while($row = $res->FetchRow()) {
                if(is_numeric($row["id_assigned"])) {
                    $arr_result[$i]["assigned"]=$this->all_names[$row["id_assigned"]];
                }
                if ($row["id_owner"]>-1) {
                    $arrowner = $this->all_names[$row["id_owner"]];
                    if(!empty($row4["email"])) {
                        $arr_result[$i]["owner"]="<a href=\"mailto:".$arrowner[$i]["email"]."\">".$arrowner."</a>";
                    } else {
                        $arr_result[$i]["owner"]=$arrowner;
                    }
                }
    
                
     
//                $arr_result[$i]["priorityColor"]=$def_priorityColor[$arr_result[1][$i]["id_priority"]];
                $arr_result[$i]["priority"]=$this->prioritylist[$row["id_priority"]];
                $arr_result[$i]["severity"]=$this->severitylist[$row["id_severity"]];
                $arr_result[$i]["resolution"]=$this->resolutionlist[$row["id_resolution"]];                        
                $arr_result[$i]["status"]=$this->statuslist[$row["id_status"]];                        
                $arr_result[$i]["id"]=$row["id"];                        
                $arr_result[$i]["short_desc"]=$row["short_desc"];                        
                $myid=$row["id"];
                // create Action URLs
                $detlink = "<a href=\"".$_SERVER["PHP_SELF"]."?action=detail&id_ticket=$myid&".SID."\" CLASS=\"edit\">$detailsym</a>";
    
                // modify only for user with appropriate rights
    		if((queryRights2_bool('root_modules_tts2_modify') and $row["id_owner"] ==$user)
    			 || (queryRights2_bool('root_modules_tts2_modifyothers') and $row["id_owner"] <> $user)) {
                    $editlink = "<a href=\"".$_SERVER["PHP_SELF"]."?action=editform&id_ticket=$myid&act=$action&".SID."\" CLASS=\"edit\">$editsym</a>";
                }
                else {
                    $editlink = "";
                }
    
                // make a new commentlink only for user with appropriate rights
                if((queryRights2_bool('root_modules_tts2_modify') and $row["id_assigned"] == $user)
                        || (queryRights2_bool('root_modules_tts2_modifyothers') and $row["id_assigned"] <> $user)) {
                    $commentlink = "<a href=\"".$_SERVER["PHP_SELF"]."?action=newcomment&id_ticket=$myid&npage=$npage&".SID."\" CLASS=\"delete\">".Lang::getLanguageString("comment")."</a>";
                }
                else {
                    $commentlink = "";
                }
    
                $unpauselink = "<a href=\"".$_SERVER["PHP_SELF"]."?action=unpause&id_ticket=$myid&".SID."\" CLASS=\"edit\">".Lang::getLanguageString("unpause")."</a>";
                $space = "&nbsp;&nbsp;";
		if ($pause_count >0) {
                   $urls[] = $detlink . $space . $commentlink . $space . $unpauselink;
		} else {
                   $urls[] = $detlink . $space . $editlink .$space . $commentlink;
		}
    
                $mailto[] = "<a href=\"mailto:" . $row["email"] . "\">" . $row["email"] . "</a>";
    
                if($row["ispublic"]==1) $images[] = "&nbsp;";
                else $images[] = $privsym;
    
                $i++;
        }
        $smarty->assign('urls', $urls);    
        $smarty->assign('tout',$arr_result);
    
	//ASSIGN COMBOBOXES

        //PRIORITY
        $smarty->assign("priority", Lang::getLanguageString("priority"));
        $sb = new mSelectBox("id_priority",$id_priority);
        $sb->setContentType("arr");
        $sb->addContent($this->prioritylist);
        $smarty->assign("prioritysb", $sb->draw());
        unset($sb);            
            
        //SEVERITY
        $smarty->assign("severity", Lang::getLanguageString("severity"));
        $sb = new mSelectBox("id_severity",$id_severity);
        $sb->setContentType("arr");
        $sb->addContent($this->severitylist);
        $smarty->assign("severitysb", $sb->draw());
        unset($sb9);    
         
        //RESOLUTION
        $smarty->assign("resolution", Lang::getLanguageString("resolution"));
        $sb = new mSelectBox("id_resolution",$id_resolution);
        $sb->setContentType("arr");
        $sb->addContent($this->resolutionlist);
        $smarty->assign("resolutionsb", $sb->draw());
        unset($sb);     

        //STATUS
        $smarty->assign("status", Lang::getLanguageString("status"));
        $sb = new mSelectBox("id_status",$id_status);
        $sb->setContentType("arr");
        $sb->addContent($this->statuslist);
        $smarty->assign("statussb", $sb->draw());
        unset($sb);     

	//OWNER
	$con = $conn->Concat('u.lastname', "', '",'u.firstname');
        $sql="SELECT DISTINCT $con AS owner, u.id FROM mgw_tts2 t, mgw_users u WHERE t.id_owner=u.id";
        $sb = new mSelectBox("id_owner",$id_owner);
        $sb->setContentType("sql");
        $sb->setSQLvalue("id");
        $sb->setSQLcontent("owner");
        $sb->addContent($sql);
        $sb->addOption("-1", Lang::getLanguageString("undetermined"), "pre");
        $smarty->assign("ownersb", $sb->draw());
        unset($sb);
            
	//ASSIGNED
	$con = $conn->Concat('u.lastname', "', '",'u.firstname');
        $sql="SELECT DISTINCT $con AS assigned, u.id FROM mgw_tts2 t, mgw_users u WHERE t.id_assigned=u.id";
        $sb12 = new mSelectBox("id_assigned",$id_assigned);
        $sb12->setContentType("sql");
        $sb12->setSQLvalue("id");
        $sb12->setSQLcontent("assigned");
        $sb12->addContent($sql);
        $sb12->addOption("-1", Lang::getLanguageString("undetermined"), "pre");
        $smarty->assign("assignedsb", $sb12->draw());
        unset($sb12);

	// PROJECT
        $sql="SELECT DISTINCT c.project_id, c.title FROM mgw_tts2 t, mgw_projects c WHERE t.id_project = c.project_id";
        $sb = new mSelectBox("id_project",$id_project);
        $sb->setContentType("sql");
        $sb->setSQLvalue("project_id");
        $sb->setSQLcontent("title");
        $sb->addContent($sql);
        $sb->addOption("-1", Lang::getLanguageString("undetermined"), "pre");
        $smarty->assign("projectsb", $sb->draw());
        unset($sb);

	// COMPANY
        $sql="SELECT id, name1 FROM mgw_companies";
        $sb = new mSelectBox("id_company", $id_company);
        $sb->setContentType("sql");
        $sb->setSQLvalue("id");
        $sb->setSQLcontent("name1");
        $sb->addContent($sql);
        $sb->addOption("-1", Lang::getLanguageString("undetermined"), "pre");
        $smarty->assign("companysb", $sb->draw());
  
        $smarty->assign("hascreaterights", queryRights2_bool('root_modules_tts_write'));
        $smarty->assign('action', Lang::getLanguageString("action"));
        $smarty->assign('suname', Lang::getLanguageString("search"));
        $smarty->assign('suvalue', Lang::getLanguageString("search"));
        $smarty->assign('suclass', "submit");
    
        $smarty->display("tts2_list.tpl",$user);
    
    	return true;
    }

    function AddHistory($id_ticket, $info, $modifier, $curstatus=-1, $duration=0) {
	global $conn;

	// UPDATE end_date OF PREVIOUS HISTORY RECORD
	$sql = "UPDATE mgw_tts2_history SET end_date=". $conn->DBTimeStamp(time())." WHERE id=$id_ticket";
	if(!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

	// INSERT NEW HISTORY RECORD
	$ticket_history_index = mgw_genID('mgw__seq_tts2_history');
	$sql = "SELECT oldstatus, curstatus from mgw_tts2_history where id_ticket=".$id_ticket;
	if(!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	$res->MoveLast();
	$row = $res->FetchRow();
	$oldstatus=$row["curstatus"];
	if (empty($oldstatus)) {
	   $oldstatus=0;
	}
	if ($curstatus==-1) {
	   $curstatus=$oldstatus;
	}

	$sql="INSERT INTO mgw_tts2_history (id, id_ticket, id_owner, info, duration, start_date, end_date, oldstatus, curstatus) 
	      VALUES ($ticket_history_index, $id_ticket, $modifier, $info, $duration,".$conn->DBTimeStamp(time()).",'".ISOZERODATE."',$oldstatus,$curstatus)";
        if(!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

	// Trigger workflow initiation, since we can determine easily here
	// wheter or not a ticket moved to workflow controlled state
	if ($oldstatus != $curstatus && $this->status_wflist[$curstatus]>0
	    && $oldstatus != $this->status_pause) {
	    // include function from workflow module
	    // and call function with correct id
	    $URI=ROOTURL."/modules/workflow/autorun_activity.php?id=$id_ticket&activityId=".$this->status_wflist[$curstatus]."&auto=1&module=1";
            $fp = fopen($URI,"r");
	    $data = '';
      	    if (!$fp) {
        	trigger_error("Fatal error: cannot execute automatic activity $activityId",E_USER_WARNING);
        	die;
      	    }
      	    while (!feof($fp)) {
        	$data.=fread($fp,8192);
      	    }
	    fclose($fp);
	}
	return true;
    }

    function GetAllUserNames() {
	global $conn;
        $concat=$conn->Concat("lastname", "', '", "firstname");

        $sql="SELECT $concat AS name, id FROM mgw_users";

        if(!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
        while(!$res->EOF) {
            $name[$res->Fields("id")] = $res->Fields("name");
            $res->movenext();
        }
	$this->all_names=$name;
    }

    function GetAllComments($id) {
	global $conn;

	$comments=array();
	$sql = "SELECT * from mgw_tts2_history WHERE id_ticket=$id";
        if(!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
        while ($row = $res->FetchRow()) {
   	   $start_date=$row["start_date"];
	   $curstatus=$this->statuslist[$row["curstatus"]];
	   $oldstatus=$this->statuslist[$row["oldstatus"]];
	   $modifier=$this->all_names[$row["id_owner"]];
	   $info=$row["info"];
	   $commentline="By user $modifier, on $start_date:\n";
	   if ($curstatus!=$oldstatus) {
		$commentline.= "==> User changed state from $oldstatus to $curstatus\n";
	   }
	   $commentline.=$info;
	   $comments[]=$commentline;
        };
        return $comments;
    }

    function GetWorkflowActivities() {
        global $conn;

	include_once('../workflow/inc/Galaxia/config.php');
	require_once (GALAXIA_LIBRARY.'/API.php');
	$instance->getInstance($this->id_wfinstance);
	return $instance->activities;
    }

    function load() {
	global $conn, $def_priority, $def_status, $def_severity, $def_resolution, $def_status_pause, $def_status_wf ;
	$this->GetAllUserNames();
	if ($this->id_ticket>0) {
            $sql="SELECT * FROM mgw_tts2 WHERE id=$this->id_ticket";
            if(!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
	    $row=$res->FetchRow();
	    $this->id_project=$row["id_project"];
	    $this->id_company=$row["id_company"];
	    $this->id_priority=$row["id_priority"];
	    $this->id_severity=$row["id_severity"];
	    $this->id_resolution=$row["id_resolution"];
	    $this->id_owner=$row["id_owner"];
	    $this->id_assigned=$row["id_assigned"];
	    $this->id_status=$row["id_status"];
	    $this->id_wfinstance=$row["id_wfinstance"];
	    $this->short_desc=$row["short_desc"];
	    $this->long_desc=$row["long_desc"];
	}
	$this->prioritylist=$def_priority;
	$this->statuslist=$def_status;
	$this->severitylist=$def_severity;
	$this->resolutionlist=$def_resolution;
	$this->status_wflist=$def_status_wf;
	$this->status_pause=$def_status_pause;
    }
}

?>
